/* Copyright 2025, Michele "King_DuckZ" Santullo
 * This file is part of ducktorrent.
 *
 * Ducktorrent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ducktorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ducktorrent.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "ducktorrent/parser.hpp"

#include <cstddef>
#include <ostream>

namespace duck {
class DebugVisitor {
public:
	DebugVisitor(int depth=0, bool skip_first=true);
	DebugVisitor(std::ostream& out, int depth=0, bool skip_first=true);

	void reset();
	void operator() (TorrentIntType value);
	void operator() (const TorrentStringType& value);
	void operator() (const std::vector<duck::TorrentValue>& value);
	void operator() (const std::map<duck::TorrentStringType, duck::TorrentValue>& value);

private:
	void print_tabs(int extra=0);

	std::ostream& m_out;
	int m_depth;
	bool m_first_line;
	bool m_skip_first;
};
} //namespace duck
